/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


import Class.Division;
import Class.Employee;
import Class.Religion;
import Class.dbConnect;
import java.awt.HeadlessException;
import java.sql.ResultSet;
import javax.swing.JOptionPane;
import java.sql.Statement;
import java.sql.SQLException;
import javax.swing.table.*;
import java.util.*;


/**
 *
 * @author Sayyid
 */
public class Main extends javax.swing.JFrame {
    ResultSet rs;
    Statement stmt;
    dbConnect cn = new dbConnect();
    /**
     * Creates new form Main
     */
    public Main() {
        initComponents();
//        employeeTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
//        public void valueChanged(ListSelectionEvent event) {
//            // do some actions here, for example
//            // print first column value from selected row
//            System.out.println(table.getValueAt(table.getSelectedRow(), 0).toString());
//        }
//    });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextNIP = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextNama = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jComboDivisi = new javax.swing.JComboBox<>();
        jLabel5 = new javax.swing.JLabel();
        jTextTgl = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jComboJKel = new javax.swing.JComboBox<>();
        jLabel8 = new javax.swing.JLabel();
        jComboAgama = new javax.swing.JComboBox<>();
        jLabel9 = new javax.swing.JLabel();
        jTextTelp = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAlamat = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        employeeTable = new javax.swing.JTable();
        jButtonInsert = new javax.swing.JButton();
        jButtonUpdate = new javax.swing.JButton();
        jButtonDelete = new javax.swing.JButton();
        jButtonExit = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        jLabel1.setText("Data Pegawai");

        jLabel2.setText("NIP");

        jTextNIP.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextNIPActionPerformed(evt);
            }
        });

        jLabel3.setText("Nama");

        jTextNama.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextNamaActionPerformed(evt);
            }
        });

        jLabel4.setText("Divisi");

        jLabel5.setText("Tanggal Lahir");

        jLabel7.setText("Jenis Kelamin");

        jComboJKel.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Pria", "Wanita" }));

        jLabel8.setText("Agama");

        jLabel9.setText("No Telepon");

        jLabel10.setText("Alamat");

        jTextAlamat.setColumns(20);
        jTextAlamat.setRows(5);
        jScrollPane1.setViewportView(jTextAlamat);

        employeeTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        employeeTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                employeeTableMouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(employeeTable);

        jButtonInsert.setText("Insert");
        jButtonInsert.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonInsertActionPerformed(evt);
            }
        });

        jButtonUpdate.setText("Update");
        jButtonUpdate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonUpdateActionPerformed(evt);
            }
        });

        jButtonDelete.setText("Delete");
        jButtonDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteActionPerformed(evt);
            }
        });

        jButtonExit.setText("Exit");
        jButtonExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonExitActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jButtonExit, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 33, Short.MAX_VALUE)
                                        .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel5))
                                .addGap(14, 14, 14)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTextNIP, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextNama, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(jComboDivisi, javax.swing.GroupLayout.Alignment.LEADING, 0, 90, Short.MAX_VALUE)
                                        .addComponent(jTextTgl, javax.swing.GroupLayout.Alignment.LEADING)))
                                .addGap(42, 42, 42)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel8)
                                    .addComponent(jLabel9)
                                    .addComponent(jLabel10))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 222, Short.MAX_VALUE)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                .addComponent(jComboAgama, 0, 90, Short.MAX_VALUE)
                                                .addComponent(jComboJKel, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                            .addComponent(jTextTelp, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGap(0, 0, Short.MAX_VALUE))))
                            .addComponent(jScrollPane2)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jButtonInsert, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButtonUpdate, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButtonDelete, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE)))))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(jLabel1)
                .addGap(232, 232, 232))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextNIP, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(jComboJKel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextNama, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(jComboAgama, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jComboDivisi, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9)
                    .addComponent(jTextTelp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel5)
                        .addComponent(jTextTgl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel10))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonInsert)
                    .addComponent(jButtonUpdate)
                    .addComponent(jButtonDelete))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 119, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButtonExit)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void hapusTabel(){
        int row = employeeTable.getRowCount();
        DefaultTableModel Dt =(DefaultTableModel) employeeTable.getModel();
        for(int i=0;i<row;i++){
            Dt.removeRow(0);
        }
    }
    
    public void tampilData(){
        hapusTabel();
        try{
            ResultSet employees = Employee.fetch();
            DefaultTableModel dt = (DefaultTableModel)employeeTable.getModel();
            if(employeeTable.getColumnCount() == 0){
                dt.addColumn("NIP");
                dt.addColumn("Nama");
                dt.addColumn("Divisi");
                dt.addColumn("Tgl Lahir");
                dt.addColumn("Agama");
                dt.addColumn("No Telp");
            }
            while(employees.next()){
                String tNip= employees.getString("NIP");
                String tNama = employees.getString("name");
                String tDivisi = employees.getString("division");
                String tTgl = employees.getString("dob");
                String tAgama = employees.getString("religion");
                String tTelp = employees.getString("phone");
                String [] data = {tNip,tNama,tDivisi,tTgl,tAgama,tTelp};
                dt.addRow(data);
            }
        }catch(SQLException e){ 
            JOptionPane.showMessageDialog(rootPane,"Error : "+ e);
        }
    }
    
    public void clearForm()
    {
        jTextNIP.setText("");
        jComboDivisi.setSelectedItem(0);
        jTextNama.setText("");
        jTextTgl.setText("");
        jComboAgama.setSelectedItem(0);
        jComboJKel.setSelectedItem(0);
        jTextTelp.setText("");
        jTextAlamat.setText("");
    }
    
     public void fetchDivisionOptions(){
        try{
            ResultSet divisions = Division.fetch();
            while(divisions.next()){
                String tDivisi = divisions.getString("name");
                jComboDivisi.addItem(tDivisi);
            }
        }catch(SQLException e){ 
            JOptionPane.showMessageDialog(rootPane,"Error : "+ e);
        }
    }
     
    public void fetchReligionOptions(){
        try{
            ResultSet religions = Religion.fetch();
            while(religions.next()){
                String tReligion = religions.getString("name");
                jComboAgama.addItem(tReligion);
            }
        }catch(SQLException e){ 
            JOptionPane.showMessageDialog(rootPane,"Error : "+ e);
        }
    }
     
    private void jTextNIPActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextNIPActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextNIPActionPerformed

    private void jTextNamaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextNamaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextNamaActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        // TODO add your handling code here:
        tampilData();
        fetchDivisionOptions();
        fetchReligionOptions();
    }//GEN-LAST:event_formWindowOpened

    private void jButtonExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonExitActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_jButtonExitActionPerformed

    private void jButtonInsertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonInsertActionPerformed
        // TODO add your handling code here:
        try{
            boolean isSuccess = Employee.insert(
                    jTextNIP.getText(),
                    jTextNama.getText(),
                    jComboDivisi.getSelectedItem().toString(),
                    jTextTgl.getText(),
                    jComboJKel.getSelectedItem().toString(),
                    jComboAgama.getSelectedItem().toString(),
                    jTextTelp.getText(),
                    jTextAlamat.getText()
            );
            if(isSuccess){
                JOptionPane.showMessageDialog(this, "Data berhasil dimasukkan");
                tampilData();
                clearForm();
            }else{
                JOptionPane.showMessageDialog(this, "Lengkapi form");
            }
        }catch(Exception e){
            System.out.println("Error :"+e);
        }
    }//GEN-LAST:event_jButtonInsertActionPerformed

    private void employeeTableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_employeeTableMouseClicked
        // TODO add your handling code here:
        try{
            int row=employeeTable.getSelectedRow();
            String tableClick=employeeTable.getModel().getValueAt(row, 0).toString();
            String sql="select * from employees where NIP='"+tableClick+"'";
            rs=cn.lihatData(sql);
            if(rs.next()){
                String tNip= rs.getString("NIP");
                String tNama = rs.getString("name");
                String tDivisi= rs.getString("division");
                String tTgl = rs.getString("dob");
                String tJKel = rs.getString("gender");
                String tAgama = rs.getString("religion");
                String tTelp = rs.getString("phone");
                String tAlamat = rs.getString("address");
                
                jTextNIP.setText(tNip);
                jTextNama.setText(tNama);
                jComboDivisi.setSelectedItem(tDivisi);
                jTextTgl.setText(tTgl);
                jComboJKel.setSelectedItem(tJKel);
                jComboAgama.setSelectedItem(tAgama);
                jTextTelp.setText(tTelp);
                jTextAlamat.setText(tAlamat);
            }
        }catch(SQLException e){
            JOptionPane.showMessageDialog(this, e);
        }
    }//GEN-LAST:event_employeeTableMouseClicked

    private void jButtonUpdateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonUpdateActionPerformed
        // TODO add your handling code here:
        try{
            int row=employeeTable.getSelectedRow();
            if(row < 0){
                JOptionPane.showMessageDialog(this, "Anda belum memilih data");
            }else{
                String nip=employeeTable.getModel().getValueAt(row, 0).toString();
                Employee.update(
                        nip,
                        jTextNIP.getText(),
                        jTextNama.getText(),
                        jComboDivisi.getSelectedItem().toString(),
                        jTextTgl.getText(),
                        jComboJKel.getSelectedItem().toString(),
                        jComboAgama.getSelectedItem().toString(),
                        jTextTelp.getText(),
                        jTextAlamat.getText()
                );
                tampilData();
                JOptionPane.showMessageDialog(this, "Data Sudah diupdate");
            }
        }catch(HeadlessException e){
            System.out.println("Error :"+e);
        }
    }//GEN-LAST:event_jButtonUpdateActionPerformed

    private void jButtonDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteActionPerformed
        // TODO add your handling code here:
        try{
            int row = employeeTable.getSelectedRow();
            if(row < 0){
                JOptionPane.showMessageDialog(this, "Anda belum memilih data");
            }else{
            
                String NIP = employeeTable.getModel().getValueAt(row, 0).toString();
                Employee.delete(NIP);
                JOptionPane.showMessageDialog(this,"Data berhasil di delete");
                tampilData();
                clearForm();
            }
        }catch(HeadlessException e){
            JOptionPane.showMessageDialog(this,"Error : "+ e);
        }
    }//GEN-LAST:event_jButtonDeleteActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Main().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable employeeTable;
    private javax.swing.JButton jButtonDelete;
    private javax.swing.JButton jButtonExit;
    private javax.swing.JButton jButtonInsert;
    private javax.swing.JButton jButtonUpdate;
    private javax.swing.JComboBox<String> jComboAgama;
    private javax.swing.JComboBox<String> jComboDivisi;
    private javax.swing.JComboBox<String> jComboJKel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTextAlamat;
    private javax.swing.JTextField jTextNIP;
    private javax.swing.JTextField jTextNama;
    private javax.swing.JTextField jTextTelp;
    private javax.swing.JTextField jTextTgl;
    // End of variables declaration//GEN-END:variables
}
